#!/usr/bin/perl 


# backup.pl typed very carefully by rcoplen@corespace.com . <-- Send complaints there. 
# Again, standard warnings apply. If you're using this to learn the language, 
# you might be better off learning from a different crazy person. 
# We'll try to keep this one looking like it was written by one guy. 
#
#  Version: 0.5 
#       (it's butt ugly, it's not totally feature complete. But it has no known bugs, and actually peforms all of its tasks)
#       TODO: Clean it up a lot, do any error reporting, and check for values to be populated once in awhile. 
#



# Some paths, requirements, modules to make things easier and a few global vars
use FindBin;
use Data::Dumper qw(Dumper);
use lib "$FindBin::Bin/..";
use lib "/var/www/easyscp/engine/";
require 'easyscp_common_code.pl';

use diagnostics;
use strict;
use warnings;
#no warnings qw(once);
use Cwd; 
use Getopt::Long;
use Storable;

# Arg processing

my $verbose = '';
my $domain = '';
my $dry_run = '';
GetOptions ('verbose' => \$verbose, 'dry_run' => \$dry_run );

if ( $verbose ) { 
	print "Verbose Mode ON \n" ;

	};

if ( $dry_run) {
	print "Dry Run Mode ON \n";
	print "We're not going to do much but dump some output. \n \n";
		
	};

if ( !defined $ARGV[0]  ) {
	print "Usage: \n";
	print "$0 [OPTIONS] <domain name> \n";
	print "Avaliable options: \n";
	print " --verbose \n";
	print " --dry_run \n";
	exit 1 ;
	} else {
	 $domain=$ARGV[0];
}

my $cwd = getcwd(); 
my $backup_dir = $cwd."/archive" ;
my $dmn_backup_dir = $backup_dir."/".$domain ; 
my $zip = $main::cfg{'ZIP'};

my %total_config = ();
my $total_config = \%total_config;
my $all_domains_subdomains_aliases = '';
my $backup_mail_cmd ='';
my $mail_backup_filename = "$domain-mail.tar.gz";

# Grab the domain info from the EasyScp database
my ($result, $result_data, $sql_query) = ( undef, undef, undef ); 
my %result_data = ();
$sql_query = " SELECT domain_id,domain_name,domain_uid,domain_gid FROM domain  where domain_name='$domain' " ; 
if (!defined $main::db || !ref $main::db) {
	$main::db = DBI->connect(@main::db_connect, {PrintError => 0});
	if (!defined $main::db) {
	print "nope, not yet, Ryan \n";
	return (-1, '');
	# DB: use always UTF8
        } elsif ($main::cfg{'DATABASE_UTF8'} eq 'yes' ) {
                        $result_data = $main::db->do("SET NAMES 'utf8';");
          }
}



 #($result, $result_data) = doHashSQL($sql_query); 
  $result_data = $main::db->selectrow_hashref($sql_query);

if ( $result_data <  0 ) {
	print "Problem connecting to the databse! \n";
	 
	exit 1 ; 
 
} 


if ( $verbose ) { 
	print Dumper $result_data ;
	print "$result_data \n\n";
}





# Backup their databases. 
# Heavily cribbed from easyscp-backup-all, with unnecessary parts (for our purposes) taken out

sub backup_sql {
	my ($dmn_id, $dmn_name, $domain_uid, $domain_gid) = @_;
        #my $zip = $main::cfg{'ZIP'};
        my ($rs, $rdata, $sql) = (undef, undef, undef);
        my $dbhost = $main::cfg{'DATABASE_HOST'};
        my $dbuser = $main::cfg{'DATABASE_USER'};
        my $dbpass = decrypt_db_password($main::cfg{'DATABASE_PASSWORD'});

	if (! -d $dmn_backup_dir) {
        $result = makepath($dmn_backup_dir, $main::cfg{'ROOT_USER'}, $main::cfg{'ROOT_GROUP'}, 0755);
        return $result if ($result != 0);
	}

        foreach ($dbhost, $dbuser, $dbpass) {
                $_ =~ s/"/\\"/gm;
        }

        $sql = "SELECT `sqld_id`, `sqld_name` FROM `sql_database` WHERE `domain_id`='$dmn_id'";
        ($rs, $rdata) = doSQL($sql);
	return $rs if ( $rs != 0 ); 
        foreach (@$rdata) {

                my $db_id = @$_[0];
                my $db_name = @$_[1];
                my $db_backup_file = "$dmn_backup_dir/$db_name.sql";
		my ($db_filename, $db_compresscmd) = (undef, undef);
                my $dbname = $db_name;
                my $dbbackup = $db_backup_file;

                $dbname =~ s/"/\\"/g;
                $dbbackup =~ s/"/\\"/g;

                my $db_backupcmd = "$main::cfg{'CMD_MYSQLDUMP'} --add-drop-table --allow-keywords --quote-names";
                $db_backupcmd .= qq/ -h'$dbhost' -u'$dbuser' -p'$dbpass' '$dbname' > '$dbbackup'/;
                $db_filename = "$dbbackup.gz";
                $db_compresscmd = $main::cfg{'CMD_GZIP'}.qq/ --force '$dbbackup'/;
                $rs = sys_command_rs($db_backupcmd);
                if($rs != 0) {
                        push_el(\@main::el, 'backup_sql()', "Domain $dmn_name: ERROR: Failed to backup database $db_name!");
                        send_error_mail('backup_sql()', "Domain $dmn_name: ERROR: Failed to backup database $db_name!");
                        unlink($db_backup_file);
                        return $rs;
                }

                $rs = setfmode("$db_backup_file", $main::cfg{'ROOT_USER'}, $main::cfg{'ROOT_GROUP'}, 0444);
                if($rs != 0) {
                        push_el(\@main::el, 'backup_sql()', "Domain $dmn_name: ERROR: Can not chmod 0444 root:root file $db_backup_file!");
                        send_error_mail('backup_sql()', "Domain $dmn_name: ERROR: Can not chmod 0444 root:root file $db_backup_file!");
                        unlink($db_backup_file);
                        return $rs;
                }

                $rs = sys_command($db_compresscmd);
                if ($rs != 0) {
                        push_el(\@main::el, 'backup_sql()', "Domain $dmn_name: ERROR: Error while executing  $db_compresscmd!");
                        send_error_mail('backup_sql()', "Domain $dmn_name: ERROR: Error while executing $db_compresscmd!");
                        unlink($db_backup_file);
                        return $rs;
                }

        }
        return 0;
}



# Just in case you care what that result was from the sql query earlier. 
my %result_data_values = %$result_data; 
my $result_ref='';
my $element='';
	if ( $verbose ) { 
#	print "result value is: $result \n";
	print "result data is: ";
		while ( my ($key, $value) = each(%result_data_values)){
			print "$key => $value ";
		print "\n";
		}
	print "\n\n\n";
	}

# Some variables necessary for the statements below to be happy. 
my $cmd_tar = $main::cfg{'CMD_TAR'};
my $cmd_rm = $main::cfg{'CMD_RM'};
my $cmd_mv = $main::cfg{'CMD_MV'};
my $dmn_vir_dir = $main::cfg{'APACHE_WWW_DIR'};
my $mail_dir = $main::cfg{'MTA_VIRTUAL_MAIL_DIR'};


# Make the dir that we're going temporarily hold everything in

if (! -d $dmn_backup_dir) {
        my $create_file_result = makepath($dmn_backup_dir, $main::cfg{'ROOT_USER'}, $main::cfg{'ROOT_GROUP'}, 0755);
        return $create_file_result if ($create_file_result != 0);
}

# Create the file that the configs are going to be written to. 

my $dmn_config_file = $dmn_backup_dir."/config.ser";


        

# Subroutine to grab domain config from the DB

sub grab_domain_config {
	#print "Dumping Config args\n";
	#print Dumper \@_ ;
	my ($dmn_id, $dmn_name, $domain_uid, $domain_gid ) = ($result_data->{ 'domain_id' }, $result_data->{ 'domain_name' }, $result_data->{ 'domain_uid' }, $result_data->{ 'domain_gid' });
	my ($cnfg_result , $cnfg_data, $sql_query ) = ( undef , undef , undef ); 
	$sql_query = "SELECT `domain`.*, `admin`.* FROM `domain`, `admin` WHERE `domain`.`domain_id` ='$dmn_id' AND `admin`.`admin_id` = `domain`.`domain_admin_id`";
	#($cnfg_result , $cnfg_data ) = doSQL($sql_query);  	
	#return $cnfg_result if ($cnfg_result != 0 ); 

	if (!defined $main::db || !ref $main::db) {
	        $main::db = DBI->connect(@main::db_connect, {PrintError => 0});
        	if (!defined $main::db) {
        	return (-1, '');
        	# DB: use always UTF8
        	} elsif ($main::cfg{'DATABASE_UTF8'} eq 'yes' ) {
                        $cnfg_data = $main::db->do("SET NAMES 'utf8';");
        	 }
	}
  $cnfg_data = $main::db->selectrow_hashref($sql_query);
	if ( $verbose ) { 
		my %cnfg_data_values = %$cnfg_data ; 
		my $element = '' ; 
		print "Domain config data is: ";
		while ( my ($key, $value) = each(%cnfg_data_values)){

			if ( defined($value)){
			print "$key => $value ";
			} else {
			print "$key => NULL ";
			}
	
		print "\n";
		}
	print "\n\n\n";
        }
  
	return (%$cnfg_data);

}


sub grab_subdomain_config {

	my $dmn_id = $result_data->{ 'domain_id' };
	my ( $sd_config_result, $sd_config_data, $sql_query ) = ( undef, undef, undef );
	$sql_query = "SELECT `subdomain`.* FROM `subdomain` WHERE `subdomain`.`domain_id` = '$dmn_id'";
	
        if (!defined $main::db || !ref $main::db) {
	        $main::db = DBI->connect(@main::db_connect, {PrintError => 0});
                if (!defined $main::db) {
                return (-1, '');
                # DB: use always UTF8
                } elsif ($main::cfg{'DATABASE_UTF8'} eq 'yes' ) {
                        $sd_config_data = $main::db->do("SET NAMES 'utf8';");
                 }
        }
	
	$sd_config_data = $main::db->selectall_hashref($sql_query, 'subdomain_id' );
	        
		if ( $verbose ) {
			if (!defined $sd_config_data ){
			print "No subdomains for this domain";
			} else {
	                my %sd_cnfg_data_values = %$sd_config_data ;
	                #my %sd_cnfg_data_values = () ;
        	        my $element = '' ;
                	print "Subdomain config data is: ";
                	while ( my ($key, $value) = each(%sd_cnfg_data_values)){

                        	if ( defined($value)){
                        		print "$key => $value ";
                        	} else {
                        		print "$key => NULL ";
                        	}
                	print "\n";
			}
                }
        print "\n\n\n";
        }
	
	if ( defined $sd_config_data ){
	        return (%$sd_config_data);
	}else {	
		return;
	}

}	

sub grab_subdomain_alias_config {

	my $dmn_id = $result_data->{ 'domain_id' };
	my %sda_config_hash=();
	my ( $sda_config_result, $alias_id, $sql_query, $sda_config_data ) = (  undef, undef, undef, undef );
	foreach $alias_id (keys %{ $total_config{'aliasses'}} ) {

		$sql_query = "SELECT `subdomain_alias`.* FROM `subdomain_alias` WHERE `subdomain_alias`.`alias_id` = '$alias_id'";
	
	        if (!defined $main::db || !ref $main::db) {
		        $main::db = DBI->connect(@main::db_connect, {PrintError => 0});
                	if (!defined $main::db) {
	                return (-1, '');
        	        # DB: use always UTF8
                	} elsif ($main::cfg{'DATABASE_UTF8'} eq 'yes' ) {
                        	$sda_config_data = $main::db->do("SET NAMES 'utf8';");
	                }
        	}
	
		$sda_config_data = $main::db->selectall_hashref($sql_query, 'subdomain_alias_id' );
		$sda_config_hash{$alias_id} = $sda_config_data;
	        
			if ( $verbose ) {
				if (!defined $sda_config_data ){
				print "No subdomains for this domain alias";
				} else {
		                my %sda_cnfg_data_values = %$sda_config_data ;
	        	        #my %sda_cnfg_data_values = () ;
        	        	my $element = '' ;
	                	print "Subdomain config data is: ";
        	        	while ( my ($key, $value) = each(%sda_cnfg_data_values)){

	                        	if ( defined($value)){
        	                		print "$key => $value ";
                	        	} else {
                        			print "$key => NULL ";
                        		}
	                	print "\n";
					}
                		}
	        	print "\n\n\n";
        		}
	}
	if ( %sda_config_hash ){
	        return (%sda_config_hash);
	}else {	
		return;
	}

}

sub grab_email_config {

	my $dmn_id = $result_data->{ 'domain_id' };
	my ( $eml_config_result, $eml_config_data, $sql_query ) = ( undef, undef, undef );
	$sql_query = "SELECT `mail_users`.* FROM `mail_users` WHERE `mail_users`.`domain_id` = '$dmn_id'";
	
        if (!defined $main::db || !ref $main::db) {
                $main::db = DBI->connect(@main::db_connect, {PrintError => 0});
                if (!defined $main::db) {
                return (-1, '');
                # DB: use always UTF8
                } elsif ($main::cfg{'DATABASE_UTF8'} eq 'yes' ) {
                        $eml_config_result = $main::db->do("SET NAMES 'utf8';");
                 }
        }

	$eml_config_result = $main::db->selectall_hashref($sql_query, 'mail_id'  );
	my %eml_config_data=%$eml_config_result;
	my $user = '';
	foreach $user ( keys %eml_config_data ) { 
		if ( $eml_config_data{$user}{mail_pass} ne "_no_" ) {
			$eml_config_data{$user}{mail_pass} = decrypt_db_password($eml_config_data{$user}{mail_pass});
			if ( $verbose ) {
				print "Decrypted password: $eml_config_data{$user}{mail_pass}\n";
			}
		}
	}

	my %eml_config_data_values = %eml_config_data ;

	if ( $verbose ) {
		while ( my ( $key, $value) = each ( %eml_config_data_values)) {
                                if ( defined($value)){
                                        print "$key => $value ";
                                } else {
                                        print "$key => NULL ";
                                }
                        print "\n";
                        }
                print "\n\n\n";
        }


#	print $eml_config_data; 
#	print Dumper \%eml_config_data; 
	return (%eml_config_data);
} 	




sub grab_ftp_config {

        my $dmn_uid = $result_data->{ 'domain_uid' };
        my ( $ftp_config_result, $ftp_config_data, $sql_query ) = ( undef, undef );
        $sql_query = "SELECT `ftp_users`.* FROM `ftp_users` WHERE `ftp_users`.`uid` = '$dmn_uid'";

        if (!defined $main::db || !ref $main::db) {
                $main::db = DBI->connect(@main::db_connect, {PrintError => 0});
                if (!defined $main::db) {
                return (-1, '');
                # DB: use always UTF8
                } elsif ($main::cfg{'DATABASE_UTF8'} eq 'yes' ) {
                        $ftp_config_result = $main::db->do("SET NAMES 'utf8';");
                 }
        }

        $ftp_config_result = $main::db->selectall_hashref($sql_query, 'userid'  );

        $ftp_config_data = $ftp_config_result ;
        if ( $verbose ) {
                while ( my ( $key, $value) = each ( %$ftp_config_data)) {
                                if ( defined($value)){
                                        print "$key => $value ";
                                } else {
                                        print "$key => NULL ";
                                }
                        print "\n";
                        }
                print "\n\n\n";
        }


        return (%$ftp_config_result);
}



sub grab_domain_alias_config {

        my $dmn_id = $result_data->{ 'domain_id' };
        my ( $alias_config_result, $alias_config_data, $sql_query ) = ( undef, undef, undef );
        $sql_query = "SELECT `domain_aliasses`.* FROM `domain_aliasses` WHERE `domain_aliasses`.`domain_id` = '$dmn_id'";

        if (!defined $main::db || !ref $main::db) {
                $main::db = DBI->connect(@main::db_connect, {PrintError => 0});
                if (!defined $main::db) {
                return (-1, '');
                # DB: use always UTF8
                } elsif ($main::cfg{'DATABASE_UTF8'} eq 'yes' ) {
                        $alias_config_result = $main::db->do("SET NAMES 'utf8';");
                 }
        }

        $alias_config_result = $main::db->selectall_hashref($sql_query, 'alias_id'  );

        $alias_config_data = $alias_config_result ;
        if ( $verbose ) {
                while ( my ( $key, $value) = each ( %$alias_config_data)) {
                                if ( defined($value)){
                                        print "$key => $value ";
                                } else {
                                        print "$key => NULL ";
                                }
                        print "\n";
                        }
                print "\n\n\n";
        }


        return (%$alias_config_result);
}



sub grab_web_user_config {

        my $dmn_id = $result_data->{ 'domain_id' };
        my ( $wu_config_result, $wu_config_data, $sql_query ) = ( undef, undef, undef );
        $sql_query = "SELECT `htaccess_users`.* FROM `htaccess_users` WHERE `htaccess_users`.`dmn_id` = '$dmn_id'";

        if (!defined $main::db || !ref $main::db) {
                $main::db = DBI->connect(@main::db_connect, {PrintError => 0});
                if (!defined $main::db) {
                return (-1, '');
                # DB: use always UTF8
                } elsif ($main::cfg{'DATABASE_UTF8'} eq 'yes' ) {
                        $wu_config_result = $main::db->do("SET NAMES 'utf8';");
                 }
        }

        $wu_config_result = $main::db->selectall_hashref($sql_query, 'id'  );

        $wu_config_data = $wu_config_result ;
        if ( $verbose ) {
                while ( my ( $key, $value) = each ( %$wu_config_data)) {
                                if ( defined($value)){
                                        print "$key => $value ";
                                } else {
                                        print "$key => NULL ";
                                }
                        print "\n";
                        }
                print "\n\n\n";
        }


        return (%$wu_config_result);
}


sub grab_web_group_config {

        my $dmn_id = $result_data->{ 'domain_id' };
        my ( $wg_config_result, $wg_config_data, $sql_query ) = ( undef, undef, undef );
        $sql_query = "SELECT `htaccess_groups`.* FROM `htaccess_groups` WHERE `htaccess_groups`.`dmn_id` = '$dmn_id'";

        if (!defined $main::db || !ref $main::db) {
                $main::db = DBI->connect(@main::db_connect, {PrintError => 0});
                if (!defined $main::db) {
                return (-1, '');
                # DB: use always UTF8
                } elsif ($main::cfg{'DATABASE_UTF8'} eq 'yes' ) {
                        $wg_config_result = $main::db->do("SET NAMES 'utf8';");
                 }
        }

        $wg_config_result = $main::db->selectall_hashref($sql_query, 'id'  );

        $wg_config_data = $wg_config_result ;
        if ( $verbose ) {
                while ( my ( $key, $value) = each ( %$wg_config_data)) {
                                if ( defined($value)){
                                        print "$key => $value ";
                                } else {
                                        print "$key => NULL ";
                                }
                        print "\n";
                        }
                print "\n\n\n";
        }


        return (%$wg_config_result);
}


sub grab_web_access_config {

        my $dmn_id = $result_data->{ 'domain_id' };
        my ( $wa_config_result, $wa_config_data, $sql_query ) = ( undef, undef, undef );
        $sql_query = "SELECT `htaccess`.* FROM `htaccess` WHERE `htaccess`.`dmn_id` = '$dmn_id'";

        if (!defined $main::db || !ref $main::db) {
                $main::db = DBI->connect(@main::db_connect, {PrintError => 0});
                if (!defined $main::db) {
                return (-1, '');
                # DB: use always UTF8
                } elsif ($main::cfg{'DATABASE_UTF8'} eq 'yes' ) {
                        $wa_config_result = $main::db->do("SET NAMES 'utf8';");
                 }
        }

        $wa_config_result = $main::db->selectall_hashref($sql_query, 'id'  );

        $wa_config_data = $wa_config_result ;
        if ( $verbose ) {
                while ( my ( $key, $value) = each ( %$wa_config_data)) {
                                if ( defined($value)){
                                        print "$key => $value ";
                                } else {
                                        print "$key => NULL ";
                                }
                        print "\n";
                        }
                print "\n\n\n";
        }


        return (%$wa_config_result);
}



sub grab_dns_config {

        my $dmn_id = $result_data->{ 'domain_id' };
        my ( $dns_config_result, $dns_config_data, $sql_query ) = ( undef, undef, undef );
        $sql_query = "SELECT `domain_dns`.`alias_id`, `domain_dns`.`domain_dns`, `domain_dns`.`domain_class`, `domain_dns`.`domain_type`, `domain_dns`.`domain_text` FROM `domain_dns` WHERE `domain_dns`.`domain_id` = '$dmn_id'";

        if (!defined $main::db || !ref $main::db) {
                $main::db = DBI->connect(@main::db_connect, {PrintError => 0});
                if (!defined $main::db) {
                return (-1, '');
                # DB: use always UTF8
                } elsif ($main::cfg{'DATABASE_UTF8'} eq 'yes' ) {
                        $dns_config_result = $main::db->do("SET NAMES 'utf8';");
                 }
        }

        $dns_config_result = $main::db->selectall_hashref($sql_query, 'domain_dns_id'  );

        $dns_config_data = $dns_config_result ;
        if ( $verbose ) {
                while ( my ( $key, $value) = each ( %$dns_config_data)) {
                                if ( defined($value)){
                                        print "$key => $value ";
                                } else {
                                        print "$key => NULL ";
                                }
                        print "\n";
                        }
                print "\n\n\n";
        }
	if ( defined $dns_config_data ){

	        return (%$dns_config_data);
	} else {
		return();
	}
}	


sub grab_db_config { 

        my $dmn_id = $result_data->{ 'domain_id' };
        my ( $db_config_result, $db_config_data, $sql_query ) = ( undef, undef, undef );
        $sql_query = "SELECT `sql_database`.`sqld_name`, `sql_database`.`sqld_id` FROM `sql_database` WHERE `sql_database`.`domain_id` = '$dmn_id'";

        if (!defined $main::db || !ref $main::db) {
                $main::db = DBI->connect(@main::db_connect, {PrintError => 0});
                if (!defined $main::db) {
                return (-1, '');
                # DB: use always UTF8
                } elsif ($main::cfg{'DATABASE_UTF8'} eq 'yes' ) {
                        $db_config_result = $main::db->do("SET NAMES 'utf8';");
                 }
        }

        $db_config_result = $main::db->selectall_hashref($sql_query, 'sqld_id'  );
        $db_config_data = $db_config_result ;
        if ( $verbose ) {
                while ( my ( $key, $value) = each ( %$db_config_data)) {
                                if ( defined($value)){
                                        print "$key => $value ";
                                } else {
                                        print "$key => NULL ";
                                }
                        print "\n";
                        }
                print "\n\n\n";
        }


        return (%$db_config_data);
}



sub grab_db_user_config { 
	my ( $user, $db )  = ( undef, undef );
        my $db_info = $total_config->{'databases'};
	my %dbu_config_hash=();
	#print "we got: \n "; 
	#print Dumper \$db_info;
	my %db_data = %$db_info ;
        my ( $dbu_config_result, $dbu_config_data, $sql_query, $db_index ) = ( undef, undef, undef, undef  );
	for $db_index ( keys %db_data ) {
		#print $db_index;	
		my $db_id = $db_data{ $db_index }{ 'sqld_id' } ;
		print Dumper \$db_id;
	        $sql_query = "SELECT `sql_user`.`sqld_id`, `sql_user`.`sqlu_name`, `sql_user`.`sqlu_pass` FROM `sql_user` WHERE `sql_user`.`sqld_id` = '$db_id'";

        	if (!defined $main::db || !ref $main::db) {
                	$main::db = DBI->connect(@main::db_connect, {PrintError => 0});
	                if (!defined $main::db) {
        	        return (-1, '');
                	# DB: use always UTF8
	                } elsif ($main::cfg{'DATABASE_UTF8'} eq 'yes' ) {
        	                $dbu_config_result = $main::db->do("SET NAMES 'utf8';");
                	 }
	        }

        	$dbu_config_result = $main::db->selectall_hashref($sql_query, 'sqlu_name'  );
		if ($verbose) {
		print "dumping \$dbu_config_result";
		print Dumper \$dbu_config_result; 
		}
		$dbu_config_hash{$db_index} = $dbu_config_result  ;

	        $dbu_config_data = $dbu_config_result ;
        	if ( $verbose ) {
                	while ( my ( $key, $value) = each ( %$dbu_config_data)) {
                        	        if ( defined($value)){
                                	        print "$key => $value ";
	                                } else {
        	                                print "$key => NULL ";
                	                }
                        	print "\n";
	                        }
        	        print "\n\n\n";
	        }

	}
	foreach $db (keys %dbu_config_hash) {
		foreach $user (keys %{ $dbu_config_hash{$db}} ) {
		 ${dbu_config_hash}{$db}{$user}{'sqlu_pass'} = decrypt_db_password( ${dbu_config_hash}{$db}{$user}{'sqlu_pass'});
			if ($verbose) {
				print "dumping dbu_config_hash\n";
				print Dumper \$dbu_config_hash{$db};
			}
		}
	}

        return (%dbu_config_hash);
}


sub assemble_domains_string {
	my $subdom = '';
	my $alias = '';
	my $subdom_alias = '';
	$all_domains_subdomains_aliases = "$domain ";
	foreach $alias (keys %{ $total_config{'aliasses'}}) {
		$all_domains_subdomains_aliases .= "$total_config{'aliasses'}{$alias}{'alias_name'} ";
		foreach $subdom_alias (keys %{ $total_config{'subdomain_aliasses'}{$alias}}){
		$all_domains_subdomains_aliases .= "$total_config{'subdomain_aliasses'}{$alias}{$subdom_alias}{'subdomain_alias_name'}.$total_config{'aliasses'}{$alias}{'alias_name'} ";

		}
	}

	foreach $subdom (keys %{ $total_config{'subdomain'}}) {
		$all_domains_subdomains_aliases .= "$total_config{'subdomain'}{$subdom}{'subdomain_name'}.$domain ";
	}
	if ($verbose) {
		print "\$all_domains_subdomains_aliases is $all_domains_subdomains_aliases\n";
	}

	$backup_mail_cmd = "$cmd_tar --create --directory=$mail_dir --gzip --file=$dmn_backup_dir/$mail_backup_filename $all_domains_subdomains_aliases " ;
}


# Set some more variables 
my $backup_filename = "$domain.tar.gz";
my $web_backup_filename = "$domain-www.tar.gz";

my $backup_web_cmd = "$cmd_tar --create --directory=$dmn_vir_dir --gzip --file=$dmn_backup_dir/$web_backup_filename --exclude=phptmp --exclude=backups $domain " ;

my $backup_cmd = "$cmd_tar --create --directory=$backup_dir --gzip --file=$backup_dir/$backup_filename --exclude=phptmp --exclude=backups $domain " ;
my $cleanup_command = "/bin/rm -rf $dmn_backup_dir";


# where the magic happens
sub backup_main {
    	#print Dumper $result_data ;	
	my ($dmn_id, $dmn_name, $domain_uid, $domain_gid ) = ($result_data->{ 'domain_id' }, $result_data->{ 'domain_name' }, $result_data->{ 'domain_uid' }, $result_data->{ 'domain_gid' });
	#print "$dmn_id \n";
	#my @domain_config = grab_domain_config($dmn_id, $dmn_name, $domain_uid, $domain_gid);
	
	# Grab main EasySCP domain config, process values into total config of domain
	my %domain_config = grab_domain_config($result_data);

	$total_config{'domain'} = { %domain_config };

	if ( $verbose ) {
		print " DOMAIN CONFIG IS: ".\%domain_config;
		while  ( my ($key, $value) = each(%domain_config)) {
	
			#push %total_config , $item ;
				if (defined($value) ) { 
				print "$key => $value ";
	                        } else {
        	                print "$key => NULL ";
				}
				print "\n";

		}
	} 	


	# Grab subdomain configs, store them as well
	my %subdomain_config = grab_subdomain_config($result_data) ;

	$total_config{'subdomain'} = { %subdomain_config };
	
	# Grab email account configs, store 'em 
	my %eml_config = grab_email_config($result_data);
	$total_config{'email'} = { %eml_config };

	# Grab ftp account configs, store 'em 
	my %ftp_config = grab_ftp_config($result_data);
	$total_config{'ftp'} = { %ftp_config };
	
	# Grab domain alias configs, store 'em 
	my %alias_config = grab_domain_alias_config($result_data);
	$total_config{'aliasses'} = { %alias_config };
	
	# Grab domain alias subdomain configs, which are inexplicably named subdomain aliases
	my %sda_config = grab_subdomain_alias_config($result_data);
	$total_config{'subdomain_aliasses'} = { %sda_config };

	#Grab web (.htaccess) user configs
	my %wu_config = grab_web_user_config($result_data);
	$total_config{'web_user'} = { %wu_config };

	#Grab web (.htaccess) group configs
	my %wg_config = grab_web_group_config($result_data);
	$total_config{'web_group'} = { %wg_config };


	#Grab web (.htaccess) protected area configs
	my %wa_config = grab_web_access_config($result_data);
	$total_config{'web_access'} = { %wa_config };

	#Grab sql db configs
	my %db_config = grab_db_config($result_data);
	$total_config{'databases'} = { %db_config };


	#Grab sql db user configs
	my %dbu_config = grab_db_user_config($total_config);
	$total_config{'database_users'} = { %dbu_config };




	# As a complete formality , grab DNS configs that are in the database
	# I can't find anywhere the control panel uses this data,
	# I've never seen it populated,
	# and the ispCP backup/restore script didn't even query the right table at this point
	my %dns_config = grab_dns_config($result_data);
	$total_config{'dns'} = { %dns_config };






        if ( $verbose ) {
                print " TOTAL DOMAIN CONFIG IS: ".\%total_config."\n";
		my ( $item, $value ) = ( '' , '' ) ; 
                foreach $item ( keys %total_config )  {
			print "$item => " ;
			for $value ( keys %{ $total_config{$item}} ) {
				if ( defined($total_config{$item}{$value}) ) {
				print "  $value=$total_config{$item}{$value} " ;
                                } else {
                                print "  $value => NULL ";
                                }
                                print "\n";
			}
                }
		print Dumper \%total_config ; 
        }
	


	assemble_domains_string();











	# and of course, store all the config into a file 
	store $total_config, $dmn_config_file;






#	if ( $verbose ) {
#			print "Domain id: $dmn_id \n";
#			print "Domain Name $dmn_name \n";
#			print "Domain Uid $domain_uid \n";
#			print "Domain Gid $domain_gid \n";
#	
#			print Dumper \%total_config; ;
#			#print  %domain_config ;
#			print "\n\n\n";
#			
#	}

	# if we're not doing a dry run, actually tar up the web data+configs, sql data+configs, and mail data+configs
	if ( ! $dry_run ) {
		backup_sql($dmn_id, $dmn_name, $domain_uid, $domain_gid);

		if (length($backup_web_cmd) != 0 ) {

               		$result = sys_command($backup_web_cmd);

			#        if ($result == 0);
		}


		if (length($backup_mail_cmd) != 0 ) {

               		$result = sys_command($backup_mail_cmd);

			        if ($verbose) {
					print "\$backup_mail_cmd is $backup_mail_cmd\n"
				}
		}

		if (length($backup_cmd) != 0 ) {

               		$result = sys_command($backup_cmd);

			#        if ($result == 0);
		}
		
		system ($cleanup_command); 
	}
		
}

backup_main();
 

